divert(-1)
dnl
dnl Updates: http://anfi.homeunix.net/sendmail/rtcyrus2.html
dnl
dnl By using this file, you agree to the terms and conditions set
dnl forth in the LICENSE file which can be found at the top level of
dnl the sendmail distribution (sendmail-8.12).
dnl
dnl	Contributed by Andrzej Filip
dnl
dnl $Log: mrs_cyrus_fstat.m4,v $
dnl Revision 1.1  2007/04/16 20:37:35  anfi
dnl First version in  sourceforge CVS
dnl
dnl Revision 8.10  2004/08/11 18:22:02  anfi
dnl *** empty log message ***
dnl
dnl Revision 8.9  2004/08/11 18:13:38  anfi
dnl "stripdom" replaced by "dummy"
dnl
dnl Revision 8.8  2004/05/30 13:26:51  anfi
dnl Fixed parameters of lookup in mrs_cyrus_mailertable
dnl
dnl Revision 8.7  2004/04/05 15:44:58  anfi
dnl Added mrs_cyrus_stickyhub_local rule set.
dnl Security fixes of mrs_cyrus_stickyhub.
dnl
dnl Revision 8.6  2004/04/01 14:30:03  anfi
dnl Added "stripdom" handling in mrs_cyrus_user.
dnl Fully defined error mailer details.
dnl
dnl Revision 8.5  2004/03/18 23:28:32  anfi
dnl Fundamental rewrite.
dnl
ifdef(`_MRS_RELAY_',`',
        `errprint(`*** ERROR: FEATURE(mrs_cyrus) requires FEATURE(mrs)
')')
ifdef(`_MRS_CYRUS_',
        `errprint(`*** ERROR: There can be only one FEATURE(mrs_cyrus*)
')')
define(`_MRS_CYRUS_',`')

divert(0)
VERSIONID(`$Id: mrs_cyrus_fstat.m4,v 1.1 2007/04/16 20:37:35 anfi Exp $')
divert(-1)
define(`CYRUS_SPOOL_DIR',
        ifelse(len(X`'_ARG_), `1', `/var/spool/cyrus', _ARG_))
LOCAL_CONFIG
# Add 3 mrs_cyrus rule sets to list of valid mrs rule sets
C{MRS}mrs_cyrus_user mrs_cyrus_mailertable mrs_cyrus_stickyhub mrs_cyrus_stickyhub_local
D{CyrusSpoolDir} CYRUS_SPOOL_DIR
ifdef( `MAP_FSTAT',`',`dnl
define(`MAP_FSTAT',`')dnl
# map for checking cyrus imap mailbox existence 
Kfstat fstat
')
LOCAL_RULESETS
######################################################################
### feature mrs_cyrus rulesets to be used by feature mrs
######################################################################

Smrs_cyrus_user
R<$*> $- <@$+.>			$: <$1> $2 <@ $3 >
R<$*> $- <@$*>			$: <$1> $2 <@$3> $| $2 <$(fstat d $@ ${CyrusSpoolDir}/user/$2 $: $)>
R<$*> $- <@$*> $| $* <OK>	$# cyrusv2 $@ dummy $: $4
R<$*> $- <@$*> $| $*		$: <$1> $2 <@$3>
R<dummy> $+ <@dummy>	$@ $1
R< $~[ : $* > $*		$>MailerToTriple < $1 : $2 > $3
R< $+ > $*			$>MailerToTriple < $1 > $2
R< > $*				$# error $@ 5.1.1 $: "550 User unknown"

Smrs_cyrus_mailertable
R<$*> $- <@$+.>			$: <$1> $2 <@ $3 >
R<$*> $- <@$+> 			$: <$1> $2 <@$3> $| $2@$3 <$(fstat d $@ ${CyrusSpoolDir}/domain/$3/user/$2 $: $)> $1 <@ $2>
R<$*> $- <@$+> $| $* <OK>	$# cyrusv2d $@ dummy $: $2 <@$3>
R<$*> $- <@$*> $| $*		$: <$1> $2 <@$3>
R< $~[ : $* > $*		$>MailerToTriple < $1 : $2 > $3
R< $+ > $*			$>MailerToTriple < $1 > $2
R< > $*				$# error $@ 5.1.1 $: "550 User unknown"

Smrs_cyrus_stickyhub
R<dummy> $+ <@$+.>		$: <dummy> $1 <@ $2 >
R<dummy> $* <@dummy>		$@ $1
R<dummy> $+ <@$={VirtCyrus}> 	$: <dummy> $1 <@ $2 > $| $1@$2
R$* $| $-@$+			$: $1 $| $2@$3 <$(fstat d $@ ${CyrusSpoolDir}/domain/$3/user/$2 $: $)>
R$* $| $-@$+ <OK>		$# cyrusv2d $@ dummy $: $2 <@$3>
R$* $| $*			$# error $@ 5.1.1 $: "550 User unknown"
R<dummy> $=L <@$*>		$# ifdef(`confLOCAL_MAILER',confLOCAL_MAILER,`local') $: @$1
R<dummy> $* <@$*>		$# ifdef(`confLOCAL_MAILER',confLOCAL_MAILER,`local') $: $1

Smrs_cyrus_stickyhub_local
R<dummy> $+ <@$+.>		$: <dummy> $1 <@ $2 >
R<dummy> $* <@dummy>		$@ $1
R<dummy> $+ <@$={VirtCyrus}> 	$: <dummy> $1 <@ $2 > $| $1@$2
R$* $| $-@$+			$: $1 $| $2@$3 <$(fstat d $@ ${CyrusSpoolDir}/domain/$3/user/$2 $: $)>
R$* $| $-@$+ <OK>		$# cyrusv2d $@ dummy $: $2 <@$3>
R$* $| $*			$# error $@ 5.1.1 $: "550 User unknown"
R<dummy> $- <@$+>		$: <dummy> $1 <@$2> $| $1 <$(fstat d $@ ${CyrusSpoolDir}/user/$1 $: $)>
R$* $| $- <OK>			$# cyrusv2 $@ dummy $: $2
R$* $| $*			$: $1
R<dummy> $=L <@$*>		$# ifdef(`confLOCAL_MAILER',confLOCAL_MAILER,`local') $: @$1
R<dummy> $* <@$*>		$# ifdef(`confLOCAL_MAILER',confLOCAL_MAILER,`local') $: $1
