PUSHDIVERT(-1)
dnl
dnl By using this file, you agree to the terms and conditions set
dnl forth in the LICENSE file which can be found at the top level of
dnl the sendmail distribution (sendmail-8.12).
dnl
dnl	Original version contributed by Kenneth Murchison.
dnl	Version with cyrusv2d mailer added contributed by Andrzej Filip
dnl
dnl $Log: cyrusv2.m4,v $
dnl Revision 1.1  2007/04/13 18:56:14  anfi
dnl First version in  sourceforge CVS
dnl
dnl Revision 8.3  2004/03/18 21:38:27  anfi
dnl Changed comments prefixes to dnl to avoid m4 expansions
dnl
dnl Revision 8.2  2004/03/15 09:14:28  anfi
dnl Added "Updates:" web link.
dnl

_DEFIFNOT(`CYRUS_LMTP_SOCKET',`/var/imap/socket/lmtp')
_DEFIFNOT(`_DEF_CYRUSV2_MAILER_FLAGS', `lsDFMnqXz1')
_DEFIFNOT(`_DEF_CYRUSV2D_MAILER_FLAGS', _DEF_CYRUSV2_MAILER_FLAGS)
_DEFIFNOT(`CYRUSV2_MAILER_FLAGS',  `mA@/:|')
_DEFIFNOT(`CYRUSV2D_MAILER_FLAGS', `m')
dnl
ifdef(`CYRUSV2_MAILER_ARGS',, `define(`CYRUSV2_MAILER_ARGS', `FILE 'CYRUS_LMTP_SOCKET)')
ifdef(`CYRUSV2D_MAILER_ARGS',, `define(`CYRUSV2D_MAILER_ARGS', _CYRUS_V2_MAILER_ARGS)')
define(`_CYRUSV2_QGRP', `ifelse(defn(`CYRUSV2_MAILER_QGRP'),`',`', ` Q=CYRUSV2_MAILER_QGRP,')')dnl

POPDIVERT

#########################################
###   Cyrus V2 Mailer specification   ###
#########################################

VERSIONID(`$Id: cyrusv2.m4,v 1.1 2007/04/13 18:56:14 anfi Exp $')

Mcyrusv2,	P=[IPC], F=_MODMF_(CONCAT(_DEF_CYRUSV2_MAILER_FLAGS, CYRUSV2_MAILER_FLAGS), `CYRUSV2'),
		S=EnvFromSMTP/HdrFromL, R=EnvToL/HdrToL, E=\r\n,
		_OPTINS(`CYRUSV2_MAILER_MAXMSGS', `m=', `, ')_OPTINS(`CYRUSV2_MAILER_MAXRCPTS', `r=', `, ')_OPTINS(`CYRUSV2_MAILER_CHARSET', `C=', `, ')T=DNS/RFC822/SMTP,_CYRUSV2_QGRP
		A=CYRUSV2_MAILER_ARGS
Mcyrusv2d,	P=[IPC], F=_MODMF_(CONCAT(_DEF_CYRUSV2D_MAILER_FLAGS, CYRUSV2D_MAILER_FLAGS), `CYRUSV2D'),
		S=EnvFromSMTP/HdrFromL, R=ifdef(`_ALL_MASQUERADE_', `EnvToSMTP/HdrFromSMTP', `EnvToSMTP'), E=\r\n,
		_OPTINS(`CYRUSV2_MAILER_MAXMSGS', `m=', `, ')_OPTINS(`CYRUSV2_MAILER_MAXRCPTS', `r=', `, ')_OPTINS(`CYRUSV2_MAILER_CHARSET', `C=', `, ')T=DNS/RFC822/SMTP,_CYRUSV2_QGRP
		A=CYRUSV2_MAILER_ARGS
